//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4B4CDB1602BB.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4B4CDB1602BB.cm

//## begin module%4B4CDB1602BB.cp preserve=no
//## end module%4B4CDB1602BB.cp

//## Module: CreateContourPlotGroups%4B4CDB1602BB; Package body
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Plot/CreateContourPlotGroups.cxx

//## begin module%4B4CDB1602BB.additionalIncludes preserve=no
//## end module%4B4CDB1602BB.additionalIncludes

//## begin module%4B4CDB1602BB.includes preserve=yes
#include <XSContainer.h>
#include <XSFit/Fit/Fit.h>
#include <XSFit/Fit/Step.h>
#include <XSFit/Fit/StatMethod.h>
#include <XSFit/MCMC/ChainManager.h>
#include <XSFit/MCMC/MarginGrid.h>
#include <XSFit/MCMC/Chain.h>
#include <XSUtil/Error/Error.h>
//## end module%4B4CDB1602BB.includes

// CreateContourPlotGroups
#include <XSPlot/Plot/CreateContourPlotGroups.h>
//## begin module%4B4CDB1602BB.declarations preserve=no
//## end module%4B4CDB1602BB.declarations

//## begin module%4B4CDB1602BB.additionalDeclarations preserve=yes
Grid* ContourPolicy<Step>::getGrid()
{
   return XSContainer::fit->stepGrid();
}

void ContourPolicy<Step>::validate(const Grid* grid)
{
    if ( !grid )
    {
        // throw immediately if no step operation has ever been computed.
        throw YellowAlert( "Steppar must be run before a confidence region plot is attempted\n");
    }  
    else if ( grid->getGrid().size() == 0)
    {
        // steppar has previously run but the data are obsolete and have been removed.
        // throw.
        throw YellowAlert("The confidence region data is obsolete - re-run steppar\n");
    }  
}

Real ContourPolicy<Step>::getMinVal(const Grid* grid)
{
   // We know this is a Step grid
   return static_cast<const Step*>(grid)->bestFit();
}

void ContourPolicy<Step>::getInitLevels(const Grid* grid, RealArray& levels)
{
   levels.resize(3);
   levels[0] = 2.30;  levels[1] = 4.61;  levels[2] = 9.21;
}

string ContourPolicy<Step>::getParLabel(size_t idx, const Grid* grid)
{
   const Grid::ParameterSpec* param = grid->getParameter()[idx];
   // ParamSpec name may contain an optional [<modName>:] specifier
   // which we don't want here.
   string paramLabel(param->name);
   string::size_type colonPos = paramLabel.find(':');
   if (colonPos != string::npos)
      paramLabel = paramLabel.substr(colonPos+1);
   if ( param->units.length() != 0)
   {
       paramLabel += " (";
       paramLabel += param->units;
       paramLabel += ")";       
   }  
   return paramLabel;
}

string ContourPolicy<Step>::getYLabel(const PlotSettings& settings)
{
   const StatMethod* stat = XSContainer::fit->statMethod();
   string yLabel = settings.lookupLabelName("y:contour:statistic");
   yLabel += string(" ") + stat->scriptName();
   return yLabel;
}

string ContourPolicy<Step>::getTitle(const PlotSettings& settings, size_t nDim)
{
   const StatMethod* stat = XSContainer::fit->statMethod();
   string labelKey = (nDim == 1) ? string("t:contour:1d") : string("t:contour:2d");
   string title = settings.lookupLabelName(labelKey);
   title += string(" ") + stat->fullName();
   return title;
}

Grid* ContourPolicy<MarginGrid>::getGrid()
{
   return XSContainer::fit->chainManager()->marginGrid();
}

void ContourPolicy<MarginGrid>::validate(const Grid* grid)
{
    if ( !grid )
    {
        // throw immediately if no margin operation has ever been computed.
        throw YellowAlert("Margin command must be run before a margin plot is attempted.\n");
    }  
}

Real ContourPolicy<MarginGrid>::getMinVal(const Grid* grid)
{
   return 0.0;
}

void ContourPolicy<MarginGrid>::getInitLevels(const Grid* grid, RealArray& levels)
{
   const size_t nGrid = grid->getGrid().size();
   levels.resize(3);
   Real meanProb = 1.0/nGrid;
   levels[0] = meanProb;  levels[1] = 2.0*meanProb;  levels[2] = 3.0*meanProb;
}

string ContourPolicy<MarginGrid>::getParLabel(size_t idx, const Grid* grid)
{
   const std::vector<Chain::ParamID>& params =
                static_cast<const MarginGrid*>(grid)->paramIDs();
   const Chain::ParamID& parID = params[idx];
   string label = parID.parName;
   if (parID.units.length() != 0)
   {
       label += " (";
       label += parID.units;
       label += ")";       
   }  
   return label;
}

string ContourPolicy<MarginGrid>::getYLabel(const PlotSettings& settings)
{
   return settings.lookupLabelName("y:margin:probability");
}

string ContourPolicy<MarginGrid>::getTitle(const PlotSettings& settings, size_t nDim)
{
   string labelKey = (nDim == 1) ? string("t:margin:1d") : string("t:margin:2d");
   string title = settings.lookupLabelName(labelKey);
   return title;
}

const string ContourTraits<Step>::cmdName = string("contour");
const bool ContourTraits<Step>::addCrosshair = true;

const string ContourTraits<MarginGrid>::cmdName = string("margin");
const bool ContourTraits<MarginGrid>::addCrosshair = false;
//## end module%4B4CDB1602BB.additionalDeclarations


//## begin module%4B4CDB1602BB.epilog preserve=yes
//## end module%4B4CDB1602BB.epilog
